#!/usr/bin/php
<?php
require_once '/usr/local/esia/plugins/lib/php/CacheFile.class.php';
$CACHEDIRECTORY='/tmp/dell/';
$ERROR=array('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3);
$hardwareTypeEnym=array('Uninitialized'=>'OK',
                        'Healthy'=>'OK',
                        'Initializing'=>'OK',
                        'Failed'=>'CRITICAL',
                        'Disconnected'=>'OK',
                        'Prepare_Failed'=>'WARNING',
                        'Trigger_Update'=>'WARNING',
                        'Empty'=>'OK',
                        'Replaced'=>'CRITICAL',
                        'Prepare_Reset'=>'WARNING');


$return=$ERROR['OK'];
$SHORT_OPTS='H:T:A:w:c:hd';
$LONG_OPTS=array("warning:","critical:","help","debug",'Host:','authfile:','Type:');
$options = getopt($SHORT_OPTS, $LONG_OPTS);


if ( isset($options["help"]) || isset($options["h"]) )
{
	exit($ERROR["UNKNOWN"]);
}
if ( !isset($options["host"]) && !isset($options["H"]) )
{
    echo 'UNKNOWN: Not host specified';
	exit($ERROR["UNKNOWN"]);
}
$host 		= getParam($options,"host","H",null);
$warning 	= getParam($options,"warning","w",80);
$critical 	= getParam($options,"critical","c",90);
$authfile 	= getParam($options,"authfile","A",null);
$type 	    = getParam($options,"type","T",'env');
if (!is_file($authfile) )
{
    echo 'UNKNOWN: Authfile not found';
	exit($ERROR["UNKNOWN"]);
}
$file = file_get_contents($authfile);
$file = json_decode($file,true);
if( is_dir($CACHEDIRECTORY) == FALSE)
{
    if(mkdir($CACHEDIRECTORY,0755)==FALSE)
    {
        echo "Can't create direcotry cache $CACHEDIRECTORY\n";
        exit($ERROR['UNKNOWN']);
    }
}

$user= $file['user'];
$passwd=$file['password'];
$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, "https://$host:443/api/rest/login_session");
curl_setopt($curl, CURLOPT_USERPWD, $user.':'.$passwd);
curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "GET");
$headers = array('Accept: application/json',"Content-type: application/json");
curl_setopt($curl, CURLOPT_HEADER, 1);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
$response = curl_exec($curl);
if($response ===FALSE)
{
    echo "UNKNOWN: Authentification FAILED\n";
    exit(3);
}
if(preg_match('#DELL-EMC-TOKEN:\s+(.*)\n#',$response,$reg))
{
    $headers['DELL-EMC-TOKEN']=$reg[1];
}
$response = json_decode($response);
//$headers['DELL-EMC-TOKEN']=$response['id'];
curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
if(in_array($type,array('fan','power','drive','net','cntrl','env')))
{
    $file = new CacheFile($CACHEDIRECTORY.$host.'env.json',5);
    $data=NULL;
    if($file->isValid())
    {
        $data = $file->getData();
        $data = json_decode($data,true);
    }
    else
    {
        curl_setopt($curl, CURLOPT_HEADER, FALSE);
        curl_setopt($curl, CURLOPT_URL, "https://$host:443/api/rest/hardware?select=id,name,type,part_number,serial_number,lifecycle_state,slot,appliance(name,model)");
        $response = curl_exec($curl);
        $response = json_decode($response,true);
        $arr = array();
        foreach($response as $line)
        {
            if(array_key_exists($line['type'],$arr))
            {
                $arr[$line['type']][]=array('name'=>$line['name'],'PN'=>trim($line['part_number']),'SN'=>trim($line['serial_number']),'state'=>$line['lifecycle_state'],'slot'=>$line['slot']);
            }
            else
            {
                $arr[$line['type']]=array(array('name'=>$line['name'],'PN'=>trim($line['part_number']),'SN'=>trim($line['serial_number']),'state'=>$line['lifecycle_state'],'slot'=>$line['slot']));
            }
        }
        $file->writeData(json_encode($arr));
        $data = $arr;
    }
    $listkey=array();
    if($type=='fan')
    {
        $listkey[]='Fan';
    }
    elseif($type=='power')
    {
        $listkey[]='Power_Supply';
    }
    elseif($type=='drive')
    {
       $listkey[]='M2_Drive';
       $listkey[]='Drive';
    }
    elseif($type=='net')
    {
        $listkey[]='SFP';
    }
    elseif($type=='cntrl')
    {
        $listkey[]='Link_Control_Card';
        $listkey[]='Battery';
        $listkey[]='IO_Module';
    }
    elseif($type=='env')
    {
        $listkey[]='Appliance';
        $listkey[]='Base_Enclosure';
        $listkey[]='Expansion_Enclosure';
        $listkey[]='Node';
        $listkey[]='CDB';
        $listkey[]='Access_Module';
    }
    if(!empty($listkey))
    {
        foreach($listkey as $key)
        {
            $state='OK';
            if(array_key_exists($key,$data))
            {
                foreach($data[$key] as $elem)
                {
                    if($elem['state'] !='Empty'&& !empty($elem['state']) )
                    {
                        $state = $hardwareTypeEnym[$elem['state']];
                        echo "$state : ".$elem['name'].' (PN: '.$elem['PN'].', SN: '.$elem['SN'].') is '. $elem['state']." state\n";
                        $return = priority_state($return,$ERROR[$state]);
                    }
                }
            }
        }
    }
}
elseif($type=='alert')
{
    curl_setopt($curl, CURLOPT_HEADER, FALSE);
    curl_setopt($curl, CURLOPT_URL, "https://$host:443/api/rest/alert?select=resource_name,resource_type,severity,is_acknowledged,state,raised_timestamp,description_l10n");
    $response = curl_exec($curl);
    $alerts = json_decode($response,true);
    $arr = array();
    foreach($alerts as $alert)
    {
        $state='OK';
        if($alert['is_acknowledged']!=1 && $alert['state'] == 'ACTIVE' && $alert['resource_type'] != 'software_package')
        {
            if($alert['severity']=='Major' || $alert['severity']=='Critical')
            {
                 $state='CRITICAL';
            }
            elseif($alert['severity']=='Minor')
            {
                 $state='WARNING';
            }
            elseif($alert['severity']=='Info' || $alert['severity']=='None')
            {
                 $state='OK';
            }
            echo "$state : ".$alert['resource_type'].' ('.$alert['raised_timestamp'].'): '. $alert['description_l10n']."\n";
            $return = priority_state($return,$ERROR[$state]);
        }
    }
}
exit($return);


function getParam($options,$name1,$name2,$default=null){
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}
function priority_state($a,$b)
{
    $arr = array('CRITICAL'=>2,'WARNING'=>1,'OK'=>0,'UNKNOWN'=>3);
    $state=$a;
    if($a == $b)
    {
        $state=$a;
    }
    elseif($a == $arr['CRITICAL'] || $b ==$arr['CRITICAL'])
    {
        $state=$arr['CRITICAL'];
    }
    elseif($b ==$arr['WARNING'] && $a !=$arr['CRITICAL'])
    {
        $state=$arr['WARNING'];
    }
    elseif($b ==$arr['UNKNOWN'] && $a == $arr['OK'])
    {
        $state=$arr['UNKNOWN'];
    }
    return $state;
}
