#!/usr/bin/perl -w
######################### check_snmp_hp_ilo #################
my $Version='1.0';
# Date : February 05 2018
# Author : Victor Marin
# Help : esia-sa.com
#################################################################

use strict;
use Net::SNMP;
use Getopt::Long;
use JSON;
use lib "/usr/local/esia/plugins/lib/perl"  ;
use ESIA::SNMP;
use ESIA::PLUGIN;

use List::MoreUtils qw(uniq);
my $PROGNAME='check_snmp_hp_ilo.pl';
my $TIMEOUT = $ESIA::PLUGIN::TIMEOUT;
my %ERRORS= %ESIA::PLUGIN::ERRORS;
my ($opt_h,$opt_V, $json, $type, $PROGDESC);
ESIA::PLUGIN::arm_end_signal($TIMEOUT);
my $domain = "UDP/IPV4"; # domain UDP/IPV6;UDP/IPV4;TCP/IPV6;TCP/IPV4
my $community = "public";
my $snmp_version = 2;
my ($hostname);
my $warning='70';
my $port='161';
my $critical='80';
my $result_index;
#my @tab_value_read;
my $output = "";
my $target = "ALL";
my $val;
my $min_index = 0;
my $max_index = 100;
my $state = "OK";

my $hp_descr 					= "1.3.6.1.2.1.1.1.0";

my $hp_cpus                     = "1.3.6.1.4.1.232.1.2.2.1.1.1";
my $hp_val_cpu                  = "1.3.6.1.4.1.232.1.2.2.1.1.6";

my $hp_cntrl                    = "1.3.6.1.4.1.232.3.2.2.1.1.1";
my $hp_val_cntrl 			    = "1.3.6.1.4.1.232.3.2.2.1.1.6";

my $hp_logical_drive 		    = "1.3.6.1.4.1.232.3.2.3.1.1.1";
my $hp_logical_drive_index 	    = "1.3.6.1.4.1.232.3.2.3.1.1.2";
my $hp_logical_drive_index_val  = "1.3.6.1.4.1.232.3.2.3.1.1.4";
my $hp_logical_drive_size 	    = "1.3.6.1.4.1.232.3.2.3.1.1.9";
my $hp_logical_drive_rebuild    = "1.3.6.1.4.1.232.3.2.3.1.1.12";
my $hp_logical_drive_log_drv    = "1.3.6.1.4.1.232.3.2.3.1.1.11";

my %hp_logical_drive_text  = ( "1"  => "Other => The status of the logical drive could not be determined",
								"2"  => "This logical drive is in normal operation mode",
								"3"  => "failed => More physical drives have failed than the fault tolerance mode of the logical drive can handle without data loss",
								"4"  => "unconfigured => The logical drive is not configured",
								"5"  => "recovering",
								"6"  => "readyForRebuild",
								"7"  => "rebuilding",
								"8"  => "wrongDrive => the wrong physical drive was replaced after a physical drive failure",
								"9"  => "badConnect",
								"10"  => "overheating",
								"11"  => "shutdown",
								"12"  => "expanding",
								"13"  => "notAvailable",
								"14"  => "queuedForExpansion",
								"15"  => "multipathAccessDegraded",
								"16"  => "erasing",
								"17"  => "predictiveSpareRebuildReady",
								"18"  => "rapidParityInitInProgress",
								"19"  => "rapidParityInitPending",
								"20"  => "noAccessEncryptedNoCntlrKey",
								"21"  => "unencryptedToEncryptedInProgress",
								"22"  => "newLogDrvKeyRekeyInProgress",
								"23"  => "noAccessEncryptedCntlrEncryptnNotEnbld",
								"24"  => "The logical drive has received a request to transform from unencrypted to encrypted but this process has not yet started.",
								"25"  => "newLogDrvKeyRekeyRequestReceived"	);

my %hp_logical_drive_status = ("1"  => "UNKNOWN",
								"2" => "OK",
								"3"  => "CRITICAL",
								"4"  => "WARNING",
								"5"  => "WARNING",
								"6"  => "WARNING",
								"7"  => "WARNING",
								"8"  => "WARNING",
								"9"  => "WARNING",
								"10"  => "CRITICAL",
								"11"  => "CRITICAL",
								"12"  => "OK",
								"13"  => "CRITICAL",
								"14"  => "WARNING",
								"15"  => "WARNING",
								"16"  => "WARNING",
								"17"  => "OK",
								"18"  => "OK",
								"19"  => "OK",
								"20"  => "WARNING",
								"21"  => "WARNING",
								"22"  => "WARNING",
								"23"  => "WARNING",
								"24"  => "WARNING",
								"25"  => "WARNING");

my %hp_logical_drive_log_status = ("1"  => "UNKNOWN","2" => "OK","3"  => "CRITICAL","4"  => "CRITICAL");
my %hp_logical_drive_log_text = ("1"  => "This logical drive is unknown state","2" => "This logical drive is OK state","3"  => "This logical drive is degraded state",
								 "4"  => "This logical drive is failed state");

my $hp_physical_drive_cntrl     = "1.3.6.1.4.1.232.3.2.2.1.1.1";
my $hp_physical_drive           = "1.3.6.1.4.1.232.3.2.5.1.1.2";
my $hp_physical_drive_status    = "1.3.6.1.4.1.232.3.2.5.1.1.6";
my $hp_physical_drive_bay       = "1.3.6.1.4.1.232.3.2.5.1.1.5";
my $hp_physical_drive_model     = "1.3.6.1.4.1.232.3.2.5.1.1.3";
my $hp_physical_drive_Size      = "1.3.6.1.4.1.232.3.2.5.1.1.45";
my $hp_physical_drive_sn        = "1.3.6.1.4.1.232.3.2.5.1.1.51";

my %hp_physical_drive_text  = ( "1"  => "other","2"  => "OK","3"  => "failed","4"  => "predictiveFailure","5"  => "erasing","6"  => "eraseDone","7"  => "eraseQueued","8"  => "ssdWearOut","9"  => "notAuthenticated");
my %hp_physical_drive_status = ("1"  => "UNKNOWN","2" => "OK","3"  => "CRITICAL","4"  => "WARNING","5"  => "WARNING","6"  => "WARNING","7"  => "WARNING","8"  => "WARNING","9"  => "OK");


my $hp_smartcl          	    = "1.3.6.1.4.1.232.3.2.2.1.1.1";
my $hp_smartcl_index    	    = "1.3.6.1.4.1.232.3.2.5.1.1.2";
my $hp_smartcl_index_val	    = "1.3.6.1.4.1.232.3.2.5.1.1.57";


my %hp_smartcl_text  = ( "1"  => "other","2"  => "OK","3"  => "replaceDrive","4"  => "replaceDriveSSDWearOut");
my %hp_smartcl_status = ("1"  => "UNKNOWN","2" => "OK","3"  => "CRITICAL","4"  => "WARNING");


my $hp_psu_global_status        = "1.3.6.1.4.1.232.6.2.9.1";
my $hp_psu_condition            = "1.3.6.1.4.1.232.6.2.9.3.1.4";
my $hp_psu_bay					= "1.3.6.1.4.1.232.6.2.9.3.1.2";
my $hp_psu_status			    = "1.3.6.1.4.1.232.6.2.9.3.1.5";
my $hp_psu_redontant			= "1.3.6.1.4.1.232.6.2.9.3.1.9";

my %hp_psu_status_text  = ( "1"  => "noError",
							"2"  => "generalFailure",
							"3"  => "bistFailure",
							"4"  => "fanFailure",
							"5"  => "tempFailure",
							"6"  => "interlockOpen",
							"7"  => "epromFailed",
							"8"  => "vrefFailed",
							"9"  => "dacFailed",
							"10"  => "ramTestFailed",
							"11"  => "voltageChannelFailed",
							"12"  => "orringdiodeFailed",
							"13"  => "brownOut",
							"14"  => "giveupOnStartup",
							"15"  => "nvramInvalid",
							"16"  => "calibrationTableInvalid");
my %hp_psu_status_status  = ( "1"  => "OK",
							"2"  => "CRITICAL",
							"3"  => "CRITICAL",
							"4"  => "CRITICAL",
							"5"  => "WARNING",
							"6"  => "WARNING",
							"7"  => "WARNING",
							"8"  => "WARNING",
							"9"  => "WARNING",
							"10"  => "WARNING",
							"11"  => "CRITICAL",
							"12"  => "CRITICAL",
							"13"  => "WARNING",
							"14"  => "WARNING",
							"15"  => "WARNING",
							"16"  => "WARNING");

my $hp_temp_chassis				= "1.3.6.1.4.1.232.6.2.6.8.1.1";
my $hp_temp_index               = "1.3.6.1.4.1.232.6.2.6.8.1.2";
my $hp_temp_valCelsius       	= "1.3.6.1.4.1.232.6.2.6.8.1.4";
my $hp_temp_limit       		= "1.3.6.1.4.1.232.6.2.6.8.1.5";
my $hp_temp_sensor_type       	= "1.3.6.1.4.1.232.6.2.6.8.1.3";
my $hp_temp_status           = "1.3.6.1.4.1.232.6.2.6.8.1.6";
my $hp_temp_location            = "1.3.6.1.4.1.232.6.2.6.8.1.8";


my $hp_fan 						= "1.3.6.1.4.1.232.6.2.6.7.1.1";
my $hp_fan_index 				= "1.3.6.1.4.1.232.6.2.6.7.1.2";
my $hp_fan_index_val 			= "1.3.6.1.4.1.232.6.2.6.7.1.9";
my $hp_fan_locate				= "1.3.6.1.4.1.232.6.2.6.7.1.3";
my $hp_fan_speed				= "1.3.6.1.4.1.232.6.2.6.7.1.6";

my $exclude = "lknonelk";

my @arr_location_translate		    = ("unknown","other","unknown","system","systemBoard","ioBoard","cpu","memory","storage","removableMedia","powerSupply","ambient","chassis","bridgeCard");
my @arr_sensors_location_translate	= ( "1" => "other",
										"2" =>"unknown",
										"3" =>"system",
										"4" =>"systemBoard",
										"5" =>"ioBoard",
										"6" =>"cpu",
										"7" =>"memory",
										"8" =>"storage",
										"9" =>"removableMedia",
										"10" =>"powerSupply",
										"11" =>"ambient",
										"12" =>"chassis",
										"13" =>"bridgeCard");


sub print_commands()
{
	print "Accepted type:\n";
	print " cpu       : The Processor State\n";
	print " cntrl     : The overall condition of controllers, and any associated logical drives, physical drives, and array accelerators. FOR TESTING WITH MULTIPLES RAID CONTROLLEURS\n";
	print " raid      : Logical Drives Status. FOR TESTING WITH MULTIPLES RAID\n";
	print " disk      : Status of the physical drive\n";
	print " smart     : Physical Drive S.M.A.R.T Status.\n";
	print " pwr       : The overall condition of the fault tolerant power supply sub-system.\n";
	print " temp      : The Temperature sensor condition.\n";
	print " fan       : The condition of the fan.\n";
	print " inventory : Print hardware inventory informations\n";
}

########## FUNCTION SNMP ##########
sub check_cpus {
	my($snmp) = @_;
	my $return = $ERRORS{OK};
	my $result = $snmp->get_table(Baseoid => $hp_val_cpu);
	if(defined($result))
	{
		foreach my $key ( keys %$result)
		{
			if($key =~ /([0-9]*)$/)
			{
				my $id =$1;
				my $val_cpu = $$result{$key};
				if($val_cpu == 1)
				{
					print "UNKNOWN: CPU $id The status of the CPU could not be determined.";
					$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
				}
				elsif($val_cpu == 2)
				{
					print "OK: CPU $id is OK \n";
				}
				elsif($val_cpu == 3)
				{
					print "WARNING: CPU $id Degraded => The CPU is in a pre-failure warrantee state.";
					$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{WARNING});
				}
				elsif($val_cpu == 4)
				{
					print "CRITICAL: CPU $id Failed => The CPU is in a failed state.";
					$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{CRITICAL});
				}
				elsif($val_cpu == 5)
				{
					print "CRITICAL: CPU $id Disabled => The CPU has been disabled during power-on-self-test.";
					$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{CRITICAL});
				}
				else
				{
					print "UNKNOWN: CPU $id Unknown => The state of the CPU could not be determined.";
					$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
				}
			}
		}
	}
	else
	{
		print (" ERROR SNMP \n Verify your OID\n");
		$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
	}
	return $return;
}
sub check_cntrl
{
	my($snmp) = @_;
	my $return = $ERRORS{OK};
	my $result = $snmp->get_table(Baseoid => $hp_val_cntrl);
	if(defined($result))
	{
		my $output = "";
		foreach my $key ( keys %$result)
		{
			if($key =~ /([0-9]*)$/)
			{
				my $id =$1;
				if($id !~/$exclude/)
				{
					my $val_cntrl = $$result{$key};
					if($val_cntrl == 1)
					{
						$output .= "UNKNOWN: cntrl $id Other => The status of the controller could not be determined.\n";
						$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
					}
					elsif($val_cntrl == 2)
					{
						$output .= "OK: cntrl $id => This controller, and any associated logical drives, physical drives, and array accelerators functioning normally\n";
					}
					elsif($val_cntrl == 3)
					{
						$output .= "WARNING: cntrl $id Degraded => One or more RAIDs in controller are in degraded state.\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{WARNING});
					}
					elsif($val_cntrl == 4)
					{
						$output .= "CRITICAL: cntrl $id Failed => This controller, or any associated logical drives, physical drives, or array accelerators is in failed state.\n";
						$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{CRITICAL});
					}
					else
					{
						$output .= "UNKNOWN: cntrl $id Unknown => The state of this controller could not be determined.\n";
						$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
					}
				}
			}
		}
		if( $output eq '')
		{
			print "OK: not controller selected \n";
			$return = ESIA::PLUGIN::priority_state($return,$ERRORS{OK});
		}
		else
		{
			print  $output;
		}
	}
	else
	{
		print (" ERROR SNMP \n Verify your OID\n");
		$return =  ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
	}
	return $return;
}
sub check_logicalDrive{
	my($snmp) = @_;
	my $return = $ERRORS{OK};
	my $result = $snmp->get_table(Baseoid => "$hp_logical_drive_index_val");
	if(defined($result)) # && defined($result_index))
	{
		my $output='';
		foreach my $key ( keys %$result)
		{
			if($key =~ /([0-9]*)\.([0-9]*)$/)
			{
				my $cntrl =$1;
				my $driveid =$2;
				my $val_logicalDrive = $$result{$key};
				my $id= $cntrl.".".$driveid;
				if($id !~/$exclude/)
				{
					my $size = ESIA::SNMP::get($snmp,"$hp_logical_drive_size.$cntrl.$driveid");
					my $name = "RAID on cntrl $cntrl number $driveid";
					if(defined $size && $size =~ /^\d+?$/)
					{
						$size = sprintf("%.2f",($size/1024));
						$name = "$name $size GB";
					}
					if($val_logicalDrive > 25)
					{
						$output .= "UNKNOWN: $name => The state of this logical drive could not be determined. \n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
					}
					elsif($val_logicalDrive == 1 )
					{
						my $state = 'OK';
						my $log_state = ESIA::SNMP::get($snmp,"$hp_logical_drive_log_drv.$cntrl.$driveid");
						$state = $hp_logical_drive_log_status{$log_state};
						my $message = $hp_logical_drive_log_text{$log_state};
						$output .= "$state: $name: ".$message."\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{$state});
					}
					else
					{
						my $state = 'OK';
						$state = $hp_logical_drive_status{$val_logicalDrive};
						my $message = $hp_logical_drive_text{$val_logicalDrive};
						if($message=~/$exclude/)
						{
							$state = 'OK';
						}
						$output .= "$state: $name: ".$message."\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{$state});
					}
				}
			}
		}
		if( $output eq '')
		{
			print "OK: not logical disk selected \n";
			$return = ESIA::PLUGIN::priority_state($return,$ERRORS{OK});
		}
		else
		{
			print $output;
		}
	}
	else
	{
		print ("UNKNOWN: No logical drive found \n");
		$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN})
	}
	return $return;
}
sub check_physicalDrive
{
	my ($snmp) = @_;
	my $return = $ERRORS{OK};
	my $result = $snmp->get_table(Baseoid => $hp_physical_drive_bay);
	if(defined($result))
	{
		my $output = "";
		foreach my $key ( keys %$result)
		{
			if($key =~ /([0-9]*)\.([0-9]*)$/)
			{
				my $cntrl =$1;
				my $driveid =$2;
				my $id= $cntrl.".".$driveid;
				if($id !~/$exclude/)
				{
					my $bay = $$result{$key};
					my $model = ESIA::SNMP::get($snmp,"$hp_physical_drive_model.$cntrl.$driveid");
					my $size = ESIA::SNMP::get($snmp,"$hp_physical_drive_Size.$cntrl.$driveid");
					my $sn = ESIA::SNMP::get($snmp,"$hp_physical_drive_sn.$cntrl.$driveid");
					my $name = "$model ($size MB)";
					my $val_physicalDrive = ESIA::SNMP::get($snmp,"$hp_physical_drive_status.$cntrl.$driveid");

					if($val_physicalDrive > 9)
					{
						$output .= "UNKNOWN: disque $cntrl.$driveid <$name>$sn Baie:$bay => The state of this drive could not be determined. \n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
					}
					else
					{
						my $state = 'OK';
						$state = $hp_physical_drive_status{$val_physicalDrive};
						my $message = $hp_physical_drive_text{$val_physicalDrive};
						if($message=~/$exclude/)
						{
							$state = 'OK';
						}
						$output .= "$state: disk $cntrl.$driveid name $name SN: $sn Baie:$bay =>".$message."\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{$state});
					}
				}
			}
		}
		if( $output eq '')
		{
			print "OK: not disk selected \n";
			$return = ESIA::PLUGIN::priority_state($return,$ERRORS{OK});
		}
		else
		{
			print $output;
		}
	}
	else
	{
		print ("UNKNOWN: No physical drive found \n");
		$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
	}
	return $return;
}
sub check_smartcl {
	my ($snmp) = @_;
	my $return = $ERRORS{OK};
	my $result = $snmp->get_table(Baseoid => $hp_smartcl_index_val);
	if(defined($result))
	{
		my $output ="";
		foreach my $key ( keys %$result)
		{
			if($key =~ /([0-9]*)\.([0-9]*)$/)
			{
				my $cntrl =$1;
				my $driveid =$2;
				my $id= $cntrl.".".$driveid;
				if($id !~/$exclude/)
				{
					my $bay = ESIA::SNMP::get($snmp,"$hp_physical_drive_bay.$cntrl.$driveid");
					my $model = ESIA::SNMP::get($snmp,"$hp_physical_drive_model.$cntrl.$driveid");
					my $sn = ESIA::SNMP::get($snmp,"$hp_physical_drive_sn.$cntrl.$driveid");
					my $name = "$model ";
					my $val_smartcl = $$result{$key};

					if($val_smartcl > 5)
					{
						$output .= "UNKNOWN: smartcl $cntrl.$driveid <$name>$sn Baie:$bay => The state of this drive could not be determined. \n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
					}
					else
					{
						my $state = 'OK';
						$state = $hp_smartcl_status{$val_smartcl};
						my $message = $hp_smartcl_text{$val_smartcl};
						if($message=~/$exclude/)
						{
							$state = 'OK';
						}
						$output .= "$state: smartcl $cntrl.$driveid name $name SN: $sn Baie:$bay =>".$message."\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{$state});
					}
				}
			}
		}
		if( $output eq '')
		{
			print "OK: not smart disk selected \n";
			$return = ESIA::PLUGIN::priority_state($return,$ERRORS{OK});
		}
		else
		{
			print $output;
		}
	}
	else
	{
		print ("UNKNOWN: No physical drive S.M.A.R.T found \n");
		$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN})
	}
	return $return;
}
sub check_alim {
	my ($snmp) = @_;
	my $return = $ERRORS{OK};
	my $state = "OK";
	my $global_psu_status = ESIA::SNMP::get($snmp,$hp_psu_global_status);
	my $resultglobalstatus = $snmp->get_table(Baseoid => $hp_psu_global_status);
	foreach my $keypsy ( keys %$resultglobalstatus)
	{
		my $global_psu_status = $$resultglobalstatus{$keypsy};
		if ($global_psu_status==1)
		{
			print "UNKNOWN: global power Supply is unknown state\n";
			$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN})
		}
	}
	my $result = $snmp->get_table(Baseoid => $hp_psu_condition);
	if(defined($result))
	{
		foreach my $key ( keys %$result)
		{
			if($key =~ /([0-9]*)\.([0-9]*)$/)
			{
				my $chassisid =$1;
				my $psuid =$2;
				my $id= $chassisid.".".$psuid;
				if($id !~/$exclude/)
				{
					my $bay = ESIA::SNMP::get($snmp,"$hp_psu_bay.$chassisid.$psuid");
					my $redondante = ESIA::SNMP::get($snmp,"$hp_psu_redontant.$chassisid.$psuid");
					my $msg = " ";
					if($redondante==2)
					{
						$msg = "Non-redundant ";
					}
					elsif($redondante==3)
					{
						$msg = "Redundant ";
					}
					my $psu_statut = $$result{$key};
					my $psu_state = ESIA::SNMP::get($snmp,"$hp_psu_status.$chassisid.$psuid");
					if($psu_state > 16)
					{
						$output .= "UNKNOWN: PSU $chassisid.".".$psuid => The state of this psu could not be determined. \n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
					}
					else
					{
						my $state = 'OK';
						$state = $hp_psu_status_status{$psu_state};
						my $message = $hp_psu_status_text{$psu_state};
						if($message=~/$exclude/)
						{
							$state = 'OK';
						}
						if($psu_state != 1)
						{
							$output .= "$state: Power Supply $redondante on $bay is in error ".$message."\n";
						}
						else
						{
							$output .= "$state: Power Supply $redondante on $bay bay is OK\n";
						}
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{$state});
					}
				}
			}
		}
		if( $output eq '')
		{
			print "OK: not PSU selected \n";
			$return = ESIA::PLUGIN::priority_state($return,$ERRORS{OK});
		}
		else
		{
			print $output;
		}
	}
	return $return;
}
sub check_temp {
	my ($snmp) = @_;
	my $return = $ERRORS{OK};
	my $maxtemp_cpu = 0;
	my $maxtemp_mem = 0;
	my $maxtemp_ambient = 0;
	my $maxtemp_sys = 0;
    my $result = $snmp->get_table(Baseoid =>"$hp_temp_valCelsius");
	if(defined($result))
	{
		foreach my $key(sort keys %$result)
		{
			if($key =~ /([0-9]*)\.([0-9]*)$/)
			{
				my $temp = $$result{$key};
				my $chassisid =$1;
				my $id =$2;
				if($id !~/$exclude/)
				{
					my $limit = ESIA::SNMP::get($snmp,"$hp_temp_limit.$chassisid.$id");
					my $realstatus = ESIA::SNMP::get($snmp,"$hp_temp_status.$chassisid.$id");
					my $type = ESIA::SNMP::get($snmp,"$hp_temp_sensor_type.$chassisid.$id");
					my $sensors_state_msg= "OK";
					my $sensors_msg= "";
					if($realstatus == 1)
					{
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
						$sensors_state_msg= "UNKNOWN";
						$sensors_msg = "Temperature status could not be determined.";
					}
					elsif($realstatus == 2)
					{
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{OK});
					}
					elsif($realstatus == 3)
					{
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{WARNING});
						$sensors_state_msg= "WARNING";
						$sensors_msg = "Degraded => The temperature sensor is outside of normal operating range.";
					}
					elsif($realstatus == 4)
					{
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{CRITICAL});
						$sensors_state_msg= "CRITICAL";
						$sensors_msg = "Failed  => The temperature sensor detects a condition that could permanently damage the system.";
					}
					else
					{
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
						$sensors_state_msg= "UNKNOWN";
						$sensors_msg = "Temperature status could not be determined.";
					}
					print "$sensors_state_msg: sensor $id (".$arr_sensors_location_translate[$type].") Temperature = $temp Limit = $limit. $sensors_msg\n";
					#PARTIE POUR LE GRAPHIQUE
					if($type ==3) #système
					{
						if($temp>$maxtemp_sys)
						{
							$maxtemp_sys=$temp;
						}
					}
					elsif($type ==6) #CPU
					{
						if($temp>$maxtemp_cpu)
						{
							$maxtemp_cpu=$temp;
						}
					}
					elsif($type ==7)#MEMOIRE
					{
						if($temp>$maxtemp_mem)
						{
							$maxtemp_mem=$temp;
						}
					}
					elsif($type ==11)#AMBIENT
					{
						if($temp>$maxtemp_ambient)
						{
							$maxtemp_ambient=$temp;
						}
					}
				}
			}
		}
		print "|cpu=$maxtemp_cpu,memory=$maxtemp_mem,ambient=$maxtemp_ambient,system=$maxtemp_sys";
	}
	else
	{
		print ("UNKNOWN: No sensors found \n");
		$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN})
	}
	return $return;
}
sub check_fan {
	my ($snmp) = @_;
	my $return = $ERRORS{OK};
    my $result = $snmp->get_table(Baseoid =>"$hp_fan_index_val");
	if(defined($result))
	{
		foreach my $key ( keys %$result)
		{
				if($key =~ /([0-9]*)\.([0-9]*)$/)
				{
				my $chassisid =$1;
				my $id =$2;
				if($id !~/$exclude/)
				{
					my $val_fan = $$result{$key};
					my $index_location = ESIA::SNMP::get($snmp,"$hp_fan_locate.$chassisid.$id");
					my $location = $arr_location_translate[$index_location];
					my $speed = ESIA::SNMP::get($snmp,"$hp_fan_speed.$chassisid.$id");
					if($speed==1)
					{
						$speed="other";
					}
					elsif($speed == 2)
					{
						$speed = "normal";
					}
					elsif($speed == 3)
					{
						$speed = "high";
					}
					else
					{
						$speed="unknown";
					}
					if($val_fan==1)
					{
						print "OK: fan $id $location=$speed : OK\n";
					}
					elsif($val_fan == 2)
					{
						print "OK: fan $id $location=$speed : OK\n";
					}
					elsif($val_fan == 3)
					{
						print "WARNING: fan $id $location=$speed : degraded => A redundant fan is not operating.\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{WARNING});
					}
					elsif($val_fan == 4)
					{
						print "CRITICAL: fan $id $location=$speed : failed => A non-redundant fan is not operating.\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{CRITICAL});
					}
					else
					{
						print "UNKNOWN: fan $id => Temperature could not be determined.\n";
						$return = ESIA::PLUGIN::priority_state($return,$ERRORS{UNKNOWN});
					}
				}
			}
		}
	}
	return $return;
}
########## MAIN ##########
&Getopt::Long::config('bundling');
#on récupère les paramètres SNMP
my ($snmp, $snmperror) = ESIA::SNMP::SessionAutoCommunityVersion(@ARGV);

GetOptions(
	"V"   => \$opt_V,	"version"    => \$opt_V,
	"h"   => \$opt_h,	"help"       => \$opt_h,
	"J" => \$json,	 "json" => \$json,
	"T=s" => \$type,	 "type=s" => \$type,
	"e=s" => \$exclude,	 "exclude=s" => \$exclude,
);
# -h & --help print help
if ($opt_h)
{
    #affiche l'aide par défaut
    ESIA::SNMP::print_snmp_usage($PROGNAME,'-T state');
    my @arr;
	push(@arr,["-T","--type","type of test [see below]" ]);
	push(@arr,["-e","--exclude","exclude id of check" ]);
	ESIA::SNMP::print_snmp_help($PROGNAME,$PROGDESC,\@arr);
	print "\n";
	print_commands();
	exit $ERRORS{'OK'};
}
#on vérifie qu'on a bien un objet SNMP
if (!defined($snmp))
{
	print ("UNKNOWN: SNMP configuration error: $snmperror\n");
	exit $ERRORS{'UNKNOWN'};
}

my $model = ESIA::SNMP::get($snmp,"$hp_descr");
if(!defined $model)
{
	print ("UNKNOWN: Host not SNMP response $snmperror\n");
	exit $ERRORS{'UNKNOWN'};
}

#print "$model \n";
my $return=$ERRORS{OK};
## REGEX POUR SAVOIR QUELLE VERSION ILO
my $ilo = 0;
my $version = 0;
my $limit_version = "2.46";
$model=~ /(integrated.*Lights.*out|ilo)\D*(\d)\s(\S+)/i;
if (defined $2)
{
	$ilo = $2;
    $version = $3;
}
$target = uc $type;
if($target eq "CPU")
{
	$return = check_cpus($snmp);
}
elsif($target eq "CNTRL")
{
	$return = check_cntrl($snmp);
}
elsif($target eq "RAID")
{
	$return = check_logicalDrive($snmp);
}
elsif($target eq "DISK-ONLY")
{
	$return = check_physicalDrive($snmp);
}
elsif($target eq "DISK")
{
	$return = check_physicalDrive($snmp);
}
elsif($target eq "SMART")
{
	$return = check_smartcl($snmp);
}
elsif($target eq "DISKHEALTH")
{
	my $tmp_return = check_cntrl($snmp);
	$return = ESIA::PLUGIN::priority_state($return,$tmp_return);
	$tmp_return = check_logicalDrive($snmp);
	$return = ESIA::PLUGIN::priority_state($return,$tmp_return);
	$tmp_return = check_physicalDrive($snmp);
	$return = ESIA::PLUGIN::priority_state($return,$tmp_return);
	$tmp_return = check_smartcl($snmp);
	$return = ESIA::PLUGIN::priority_state($return,$tmp_return);
}
elsif($target eq "POWER")
{
	$return = check_alim($snmp);
}
elsif($target eq "TEMP")
{
	$return = check_temp($snmp);
}
elsif($target eq "FAN")
{
	$return = check_fan($snmp);
}
elsif($target eq "SYSTEMHEALTH")
{
	my $tmp_return = check_cpus($snmp);
	$return = ESIA::PLUGIN::priority_state($return,$tmp_return);
	$tmp_return = check_alim($snmp);
	$return = ESIA::PLUGIN::priority_state($return,$tmp_return);
	$tmp_return = check_fan($snmp);
	$return = ESIA::PLUGIN::priority_state($return,$tmp_return);
}
elsif($target eq "INVENTORY")
{
	my $result;
	my @output;

	$model =~ /Lights\-Out\s+(\d+)\s+([\d\.]+)/;
	if( defined $1 )
	{
		my %hash = (
			'name' => "iLO $1",
			'description'=>'',
			'manufacturer'=>'Hewlett-Packard',
			'model' => $model,
			'type'=>'OS',
			'serial' => '',
			'hardwareVersion' => '',
			'firmwareVersion' => $2,
		);
		push(@output, \%hash);
	}

	#CPQSTDEQ-MIB
	my $oid_cpqSeSysRomVer 				= '1.3.6.1.4.1.232.1.2.6.1';

	#CPQSINFO-MIB
	my $oid_cpqSiSysSerialNum			= '1.3.6.1.4.1.232.2.2.2.1';
	my $oid_cpqSiProductName 			= '1.3.6.1.4.1.232.2.2.4.2';

	my $firmware = ESIA::SNMP::get($snmp,"$oid_cpqSeSysRomVer.0");
	my $serial = ESIA::SNMP::get($snmp,"$oid_cpqSiSysSerialNum.0");
	$serial =~ /(\S+)/;
	$serial = $1;


	my $name = ESIA::SNMP::get($snmp,"$oid_cpqSiProductName.0");
	$name =~ /(\S+\s+\S+)\s+(\S+)\s+(\S+)/;

	if( defined $2 )
	{
		my %hash = (
			'name' => $1,
			'description'=>'',
			'manufacturer'=>'Hewlett-Packard',
			'model' => "$1 $2",
			'type'=>'CHASSIS',
			'serial' => $serial,
			'hardwareVersion' => $3,
			'firmwareVersion' => $firmware,
		);
		push(@output, \%hash);
	}

	#CPQSTDEQ-MIB
	my $oid_cpqSeCpuUnitIndex 			= '1.3.6.1.4.1.232.1.2.2.1.1.1';
	my $oid_cpqSeCpuName 				= '1.3.6.1.4.1.232.1.2.2.1.1.3';
	my $oid_cpqSeCpuSpeed				= '1.3.6.1.4.1.232.1.2.2.1.1.4';
	my $oid_cpqSeCpuCore 				= '1.3.6.1.4.1.232.1.2.2.1.1.15';
	my $oid_cpqSeCPUChipGenerationName 	= '1.3.6.1.4.1.232.1.2.2.1.1.23';
	my $oid_cpqSeCPUCoreMaxThreads 		= '1.3.6.1.4.1.232.1.2.2.1.1.25';

	$result = $snmp->get_table( $oid_cpqSeCpuUnitIndex);
	if (defined($result))
	{
		foreach my $key ( keys %$result)
		{
			my $index = $$result{"$key"};
			my $cpuName = ESIA::SNMP::get($snmp,"$oid_cpqSeCpuName.$index");

			my $cpuCore = ESIA::SNMP::get($snmp,"$oid_cpqSeCpuCore.$index");
			my $cpuThread = ESIA::SNMP::get($snmp,"$oid_cpqSeCPUCoreMaxThreads.$index");

			my $cpuSpeed = ESIA::SNMP::get($snmp,"$oid_cpqSeCpuSpeed.$index");
			$cpuSpeed/=1000;

			$cpuName =~ /((\w+)\S*\s\S+)/;
			my %hash = (
				'name' => $1,
				'description'=>"core:$cpuCore,thread:$cpuThread,frequency:$cpuSpeed GHz",
				'manufacturer'=>$2,
				'model' => $cpuName,
				'type'=>'CPU',
				'serial' => '',
				'hardwareVersion' => '',
				'firmwareVersion' => '',
			);
			push(@output, \%hash);
		}
	}

	#CPQHLTH-MIB
	my $oid_cpqHeResMem2Module 				= '1.3.6.1.4.1.232.6.2.14.13.1.1';
	my $oid_cpqHeResMem2ModuleSize 			= '1.3.6.1.4.1.232.6.2.14.13.1.6';
	my $oid_cpqHeResMem2ModuleManufacturer 	= '1.3.6.1.4.1.232.6.2.14.13.1.9';
	my $oid_cpqHeResMem2ModuleSerialNo		= '1.3.6.1.4.1.232.6.2.14.13.1.12';
	my $oid_cpqHeResMem2ModuleFrequency		= '1.3.6.1.4.1.232.6.2.14.13.1.14';
	my $oid_cpqHeResMem2ModulePartNoMfgr	= '1.3.6.1.4.1.232.6.2.14.13.1.17';

	$result = $snmp->get_table( $oid_cpqHeResMem2Module);
	if (defined($result))
	{
		foreach my $key ( keys %$result)
		{
			my $index = $$result{"$key"};
			my $size = ESIA::SNMP::get($snmp,"$oid_cpqHeResMem2ModuleSize.$index");
			if( $size == 0 )
			{
				next;
			}
			$size=POSIX::floor($size/1024);
			my $freq = ESIA::SNMP::get($snmp,"$oid_cpqHeResMem2ModuleFrequency.$index");


			my $vendor = ESIA::SNMP::get($snmp,"$oid_cpqHeResMem2ModuleManufacturer.$index");
			$vendor =~ /(\S+)/;
			$vendor = $1;
			if($vendor eq 'HP')
			{
				$vendor = 'Hewlett-Packard';
			}
			my $sn = ESIA::SNMP::get($snmp,"$oid_cpqHeResMem2ModuleSerialNo.$index");

			my $model = ESIA::SNMP::get($snmp,"$oid_cpqHeResMem2ModulePartNoMfgr.$index");
			$model =~ /(\S+)/;
			$model = $1;

			my %hash = (
				'name' => $model,
				'description'=>"Size:$size MB,Frequency:$freq MHz",
				'manufacturer'=>$vendor,
				'model' => $model,
				'type'=>'RAM',
				'serial' => '',
				'hardwareVersion' => '',
				'firmwareVersion' => '',
			);
			push(@output, \%hash);
		}
	}

	if($json)
	{
		my $out = encode_json(\@output);
		print $out;
	}
	else
    {
        my $size = @output;
        if($size != 0)
        {
            foreach my $line ( @output)
            {

                my $hash = \%$line;
                print "name: ".$hash->{name}.", model: ".$hash->{model}.", type: ".$hash->{type}.", serial: ".$hash->{serial};
                print ", hardwareVersion: ".$hash->{hardwareVersion}.", firmwareVersion: ".$hash->{firmwareVersion}."\n";
            }
            exit 0;
        }
	}
}
else
{
	print ("UNKNOWN: Incorrect or missed option -T, --type\n");
	exit $ERRORS{'UNKNOWN'};
}

exit($return);
